//+------------------------------------------------------------------+
//|                                                       atomic.mq4 |
//|                        Copyright 2013, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright 2013, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"



#property indicator_separate_window
#property indicator_minimum 0.0
#property indicator_maximum 1.0
#property indicator_buffers 2
#property indicator_color1 LimeGreen
#property indicator_color2 DarkOrange

extern string TimeFrame = "current time frame";
extern int SmoothPeriod = 25;
extern int SmoothPhase = 0;
extern bool alertsOn = FALSE;
extern bool alertsOnCurrent = FALSE;
extern bool alertsMessage = FALSE;
extern bool alertsSound = FALSE;
extern bool alertsEmail = FALSE;
double buffi1[];
double buffi2[];
double buffi3[];
int timeframe1;
bool cierto = FALSE;
bool cierto2 = FALSE;
string palabra;
string nothing = "nothing";
datetime tiempo;
string gsa156[] = {"M1", "M5", "M15", "M30", "H1", "H4", "D1", "W1", "MN"};
int gia160[] = {1, 5, 15, 30, 60, 240, 1440, 10080, 43200};
double gda164[][30];

int init() {
   IndicatorBuffers(3);
   SetIndexBuffer(0, buffi1);
   SetIndexStyle(0, DRAW_HISTOGRAM);
   SetIndexBuffer(1, buffi2);
   SetIndexStyle(1, DRAW_HISTOGRAM);
   SetIndexBuffer(2, buffi3);
   if (TimeFrame == "calculate") {
      cierto = TRUE;
      return (0);
   }
   if (TimeFrame == "getBarsCount") {
      cierto2 = TRUE;
      return (0);
   }
   timeframe1 = stringToTimeFrame(TimeFrame);
   palabra = WindowExpertName();
   IndicatorShortName(timeFrameToString(timeframe1) + "AtomicFilter");
   return (0);
}

int start() {
   double ld12;  
   double ld20;
   double ld28;
   int lshift36;
   int contador = IndicatorCounted();
   if (contador < 0) return (-1);
   if (contador > 0) contador--;
   int referen = MathMin(Bars - contador, Bars - 1);
   if (cierto2) {
      buffi1[0] = referen + 1;
      return (0);
   }
   if (cierto || timeframe1 == Period()) {
      for (int pose = referen; pose >= 0; pose--) {
         ld12 = iSmooth(High[pose + 1], SmoothPeriod, SmoothPhase, pose + 1, 0);
         ld20 = iSmooth(Low[pose + 1], SmoothPeriod, SmoothPhase, pose + 1, 10);
         ld28 = iSmooth(Close[pose], SmoothPeriod, SmoothPhase, pose, 20);
         buffi2[pose] = EMPTY_VALUE;
         buffi1[pose] = EMPTY_VALUE;
         buffi3[pose] = buffi3[pose + 1];
         if (ld28 > ld12) buffi3[pose] = -1;
         if (ld28 < ld20) buffi3[pose] = 1;
         if (buffi3[pose] == 1.0) buffi2[pose] = 1;
         if (buffi3[pose] == -1.0) buffi1[pose] = 1;
      }
      manageAlerts();
      return (0);
   }
   referen = MathMax(referen, MathMin(Bars, iCustom(NULL, timeframe1, palabra, "getBarsCount", 0, 0) * timeframe1 / Period()));
   for (pose = referen; pose >= 0; pose--) {
      lshift36 = iBarShift(NULL, timeframe1, Time[pose]);
      buffi2[pose] = EMPTY_VALUE;
      buffi1[pose] = EMPTY_VALUE;
      buffi3[pose] = iCustom(NULL, timeframe1, palabra, "calculate", SmoothPeriod, SmoothPhase, 2, lshift36);
      if (buffi3[pose] == 1.0) buffi2[pose] = 1;
      if (buffi3[pose] == -1.0) buffi1[pose] = 1;
   }
   manageAlerts();
   return (0);
}

void manageAlerts() {
   int contador;
   if ((!cierto) && alertsOn) {
      if (alertsOnCurrent) contador = 0;
      else contador = 1;
      contador = iBarShift(NULL, 0, iTime(NULL, timeframe1, contador));
      if (buffi3[contador] != buffi3[contador + 1]) {
         if (buffi3[contador] == 1.0) {
            doAlert(contador, "up");
            return;
         }
         doAlert(contador, "down");
      }
   }
}

void doAlert(int cion, string as4) {
   string concatenado;
   if (nothing != as4 || tiempo != Time[cion]) {
      nothing = as4;
      tiempo = Time[cion];
      concatenado = StringConcatenate(Symbol(), " at ", TimeToStr(TimeLocal(), TIME_SECONDS), " AtomicFilter direction changed to", as4);
      if (alertsMessage) Alert(concatenado);
      if (alertsEmail) SendMail(StringConcatenate(Symbol(), "AtomicFilter"), concatenado);
      if (alertsSound) PlaySound("alert2.wav");
   }
}

int stringToTimeFrame(string as0) {
   as0 = stringUpperCase(as0);
   for (int referen = ArraySize(gia160) - 1; referen >= 0; referen--)
      if (as0 == gsa156[referen] || as0 == "" + gia160[referen]) return (MathMax(gia160[referen], Period()));
   return (Period());
}

string timeFrameToString(int cion) {
   for (int pose = ArraySize(gia160) - 1; pose >= 0; pose--)
      if (cion == gia160[pose]) return (gsa156[pose]);
   return ("");
}

string stringUpperCase(string as0) {
   int li20;
   string lsret8 = as0;
   for (int li16 = StringLen(as0) - 1; li16 >= 0; li16--) {
      li20 = StringGetChar(lsret8, li16);
      if ((li20 > '`' && li20 < '{') || (li20 > '' && li20 < 256)) lsret8 = StringSetChar(lsret8, li16, li20 - 32);
      else
         if (li20 > -33 && li20 < 0) lsret8 = StringSetChar(lsret8, li16, li20 + 224);
   }
   return (lsret8);
}

double iSmooth(double ad0, double ad8, double ad16, int ai24, int ai28 = 0) {
   double ld80;
   double ld88;
   if (ArrayRange(gda164, 0) != Bars) ArrayResize(gda164, Bars);
   int li32 = Bars - ai24 - 1;
   if (li32 == 0) {
      for (int count36 = 0; count36 < 7; count36++) gda164[0][count36 + ai28] = ad0;
      while (count36 < 10) {
         gda164[0][count36 + ai28] = 0;
         count36++;
      }
      return (ad0);
   }
   double ld40 = MathMax(MathLog(MathSqrt((ad8 - 1.0) / 2.0)) / MathLog(2.0) + 2.0, 0);
   double ld48 = MathMax(ld40 - 2.0, 0.5);
   double ld56 = ad0 - (gda164[li32 - 1][ai28 + 5]);
   double ld64 = ad0 - (gda164[li32 - 1][ai28 + 6]);
   gda164[li32][ai28 + 7] = 0;
   if (MathAbs(ld56) > MathAbs(ld64)) gda164[li32][ai28 + 7] = MathAbs(ld56);
   if (MathAbs(ld56) < MathAbs(ld64)) gda164[li32][ai28 + 7] = MathAbs(ld64);
   gda164[li32][ai28 + 8] = gda164[li32 - 1][ai28 + 8] + (gda164[li32][ai28 + 7] - (gda164[li32 - 10][ai28 + 7])) / 10.0;
   double ld_72 = MathMin(MathMax(4.0 * ad8, 30), 150);
   if (li32 < ld_72) {
      ld80 = gda164[li32][ai28 + 8];
      for (count36 = 1; count36 < ld_72 && li32 - count36 >= 0; count36++) ld80 += gda164[li32 - count36][ai28 + 8];
      ld80 /= count36;
   } else ld80 = ((gda164[li32 - 1][ai28 + 9]) * ld_72 - (gda164[li32 - toInt(ld_72)][ai28 + 8]) + (gda164[li32][ai28 + 8])) / ld_72;
   gda164[li32][ai28 + 9] = ld80;
   if (gda164[li32][ai28 + 9] > 0.0) ld88 = (gda164[li32][ai28 + 7]) / (gda164[li32][ai28 + 9]);
   else ld88 = 0;
   if (ld88 > MathPow(ld40, 1.0 / ld48)) ld88 = MathPow(ld40, 1.0 / ld48);
   if (ld88 < 1.0) ld88 = 1.0;
   double ld_96 = MathPow(ld88, ld48);
   double ld_104 = MathSqrt((ad8 - 1.0) / 2.0) * ld40;
   double ld_112 = MathPow(ld_104 / (ld_104 + 1.0), MathSqrt(ld_96));
   if (ld56 > 0.0) gda164[li32][ai28 + 5] = ad0;
   else gda164[li32][ai28 + 5] = ad0 - ld_112 * ld56;
   if (ld64 < 0.0) gda164[li32][ai28 + 6] = ad0;
   else gda164[li32][ai28 + 6] = ad0 - ld_112 * ld64;
   double ld120 = MathMax(MathMin(ad16, 100), -100) / 100.0 + 1.5;
   double ld128 = (ad8 - 1.0) / 2.0 / ((ad8 - 1.0) / 2.0 + 2.0);
   double ld_136 = MathPow(ld128, ld_96);
   gda164[li32][ai28 + 0] = ad0 + ld_136 * (gda164[li32 - 1][ai28 + 0] - ad0);
   gda164[li32][ai28 + 1] = (ad0 - (gda164[li32][ai28 + 0])) * (1 - ld128) + ld128 * (gda164[li32 - 1][ai28 + 1]);
   gda164[li32][ai28 + 2] = gda164[li32][ai28 + 0] + ld120 * (gda164[li32][ai28 + 1]);
   gda164[li32][ai28 + 3] = (gda164[li32][ai28 + 2] - (gda164[li32 - 1][ai28 + 4])) * MathPow(1 - ld_136, 2) + MathPow(ld_136, 2) * (gda164[li32 - 1][ai28 +
      3]);
   gda164[li32][ai28 + 4] = gda164[li32 - 1][ai28 + 4] + (gda164[li32][ai28 + 3]);
   return (gda164[li32][ai28 + 4]);
}

int toInt(double ad0) {
   return (ad0);
}

